-module(etk_menu_test).

-compile(export_all).

%%
%% Create the browser window
%%

start(N) ->
    etk:start(),
    W = etk:toplevel([]),
    tk:wm([maxsize, W, 10000, 10000]),
    tk:wm([geometry, W, "550x100+100+200"]),
    tk:wm([title, W, "Escape"]),
    MenuBar = etk_menu:create_menubar(W, menu(N)),
    tk:pack(MenuBar, [{side, "top"}, {anchor, "w"}, {fill, "x"}]),
    W.

menu(0) ->
    {menubar, 
     [{menu, "File", "left", 
       [{button, [{label, "One"}]}]}]};
menu(1) ->
    {menubar, 
     [{menu, "File", "left", 
       [{button, [{label, "New Web Browser"}, {underline, 8}, 
		   {accel, "Alt+N"}]},
	{button, [{label, "Do this thing..."},
		 {func, fun() -> io:format("Click\n") end}]},
	separator,
	{button, [{label, "Open Location..."}]}]}]};
menu(2) ->
    {menubar,
     [{menu, "File", "left", 
       [{button, [{label, "New Web Browser"},{underline, 8}, 
		   {accel, "Alt+N"}]},
	separator,
	{button, [{label, "Open Location..."}]}]},
      {menu, "Options", "left",
       [{button, [{label, "General Preferences..."}]},
	{button, [{label, "Mail and News Preferences..."}]},
	separator,
	{button, [{label,"Show Toolbar"}]}]}]};
menu(3) ->
    {menubar, 
     [{menu, "Super", "left", 
       [{submenu, "Options ...",
	 [{button, [{label, "One"}]},
	  separator,
	  {button, [{label, "Two"}]}]}]}]};
menu(4) ->
    {menubar, 
     [{menu, "File", "left", 
       [{checkbutton, {0,1},[{label, "What"}]},
	{checkbutton, {0,1},[{label, "Why"}]}]}]};
menu(5) ->
    {menubar, 
     [{menu, "File", "left", 
       [{radiobutton, 1,[{label, "What"}]},
	{radiobutton, 2,[{label, "Why"}]}]}]}.








